package edu.gmu.trimdroid.soot.callgraph;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlTransient;

@XmlAccessorType(XmlAccessType.FIELD)
public class CGEdge {

	String label;
	EdgeType type;
	@XmlTransient
	CGNode fromNode;
	CGNode toNode;

	public CGEdge() {
	}

	public CGEdge(EdgeType type) {
		this.type = type;
	}

	public CGEdge(String label, EdgeType type) {
		this(type);
		this.label = label;
	}

	enum EdgeType {
		GUI, IPC, SIMPLE, SYMBOLIC
	}

	String getLabel() {
		return type.name() + (label != null ? " (" + label + ")" : "");
	}

	String getColor() {
		switch (type) {
		case GUI:
			return "firebrick";
		case IPC:
			return "dodgerblue";
		default:
			return "black";
		}
	}
}
