package edu.gmu.trimdroid.soot.callgraph;

import java.util.Arrays;
import java.util.List;

import edu.gmu.trimdroid.soot.callgraph.CGEdge.EdgeType;
import soot.PatchingChain;
import soot.SootClass;
import soot.SootMethod;
import soot.Unit;
import soot.Value;
import soot.ValueBox;
import soot.jimple.InvokeExpr;

public class SimpleNodeExtractor implements NodeExtractor {

	@Override
	public List<CGNode> extractNode(Unit unit, PatchingChain<Unit> units, SootMethod thisMethod, CGNode fromNode, SootClass rClazz) {
		CGNode toNode = extractSimpleCallNode(unit);
		if (toNode != null) {
			CGNode.connect(fromNode, toNode, new CGEdge(EdgeType.SIMPLE), false);
			return Arrays.asList(new CGNode[] { toNode });
		}
		return null;
	}

	public static CGNode extractSimpleCallNode(Unit unit) {
		List<ValueBox> useBoxes = unit.getUseBoxes();
		for (ValueBox valueBox : useBoxes) {
			Value value = valueBox.getValue();
			if (value instanceof InvokeExpr) {
				InvokeExpr invokeExpr = (InvokeExpr) value;
				SootMethod method = invokeExpr.getMethod();
				if (method.getDeclaringClass().isApplicationClass()) {
					try {
						CGNode toNode = new CGNode(method);
						return toNode;
					} catch (Exception e) {

					}
				}
			}
		}
		return null;
	}
}
